package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStat;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStats;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.function.BiConsumer;
import java.util.function.Function;

abstract class Base<T> implements SpawnerStat<T> {
  protected final String id;
  
  protected final Function<ApothSpawnerTile, T> getter;
  
  protected final BiConsumer<ApothSpawnerTile, T> setter;
  
  private Base(String id, Function<ApothSpawnerTile, T> getter, BiConsumer<ApothSpawnerTile, T> setter) {
    this.id = id;
    this.getter = getter;
    this.setter = setter;
  }
  
  public String getId() {
    return this.id;
  }
  
  public T getValue(ApothSpawnerTile spawner) {
    return this.getter.apply(spawner);
  }
}
